% 
% demo_LSCDA.m: Easy demonstaration of CDA methods
%

clear all;
N = 200;
% rand('state',1);
% randn('state',1);

Y = 2 * (rand([2,N]) - 0.5);
X = 2 * (rand([2,N]) - 0.5);
Y(1, :) = X(1, :).^2 + sqrt(0.01)*randn([1,N]);

trial = 3;

% --
% Choose one of the following methods (See each script for detail)
CDA_MAIN = @LSCDA
% CDA_MAIN = @ICCA
% CDA_MAIN = @HSIC_CDA
% CDA_MAIN = @KCCA_CDA
% --

[param log_LSCDA] = CDA_MAIN(X, Y, 'dim_U', 1, 'dim_V', 1, 'trial', trial, 'iter', 50);

fprintf('% -------------------------------------------------- %');
fprintf('Optimal projection matrices are\n');
fprintf('U = [%f %f]\n', param.opt_U);
fprintf('V = [%f %f]\n', param.opt_V);

set(0,'DefaultAxesFontSize',22); 
set(0,'DefaultTextFontSize',24); 
set (0,'DefaultAxesLineWidth',2);
set(0,'DefaultLineLineWidth', 3);
set(0,'DefaultLineMarkerSize', 26);

figure
plot(X(1,:), Y(1,:),'.b');
xlabel('x1'); ylabel('y1');
grid on;

figure
plot(X(2,:), Y(1,:),'.b');
xlabel('x2'); ylabel('y1');
grid on;

figure
plot(X(1,:), Y(2,:),'.b');
xlabel('x1'); ylabel('y2');
grid on;

figure
plot(X(2,:), Y(2,:),'.b');
xlabel('x2'); ylabel('y2');
grid on;

figure
plot(param.opt_U*X, param.opt_V*Y,'.r');
xlabel('U (x1 x2)^T'); ylabel('V (y1 y2)^T');
grid on;
