function [U V] = initialize(out_dim, param)

  if strcmp(param.opm, 'one') 
    if length(param.U0) > 0
      U = U0(out_dim, :);
      V = V0(out_dim, :);
    else
      U = rand_mat(param.dim_X, 1);
      V = rand_mat(param.dim_Y, 1);
      if size(param.opt_U,1) > 0
        U = U - (param.opt_U' * (param.opt_U * U'))';        
      end
      U = U / norm(U);
      if size(param.opt_V,1) > 0
        V = V - (param.opt_V' * (param.opt_V * V'))';
      end
      V = V / norm(V);
    end
  else
    if length(param.U0) > 0
      U = U0;
      V = V0;
    else
      U = rand_mat(param.dim_X, param.dim_U);
      V = rand_mat(param.dim_Y, param.dim_V);      
    end      
  end

% --------------------------------------------------
function M = rand_mat(d1, d2)
  M = randn(d1, d1); 
  M = M' * M;
  [M V D] = svd(M);
  M = M(1:d2, :);
  